<cfsetting enablecfoutputonly="yes" />
<!---
==========================================================================
Planning SA <www.planning.sa.gov.au>
==========================================================================
|| APPLICATION ||
Application:

|| LEGAL ||
Copyright Planning SA, Primary Industries and Resources.
All Rights Reserved.  All works and information displayed are subject to copyright.  For
the reproduction or publication beyond that permitted by the Copyright Act 1968 (Cwlth)
written permission must be sought from the Department.

Although every effort has been made to ensure the accuracy of the information displayed,
the Department, its agents, officers and employees make no representations, either express
or implied, that the information displayed is accurate or fit for any purpose and expressly
disclaims all liability for loss or damage arising from reliance upon the information displayed.

|| VERSION CONTROL ||
$RCSfile: _cfFunctions.cfm,v $
$Header: I:\\backup\\cvs/atlassa/webskin/includes/_cfFunctions.cfm,v 1.2 2005/03/10 22:54:02 whiterd Exp $
$Author: whiterd $
$Date: 2006-08-03 18:02:14 +0930 (Thu, 03 Aug 2006) $
$Name:  $
$Revision: 94 $

|| DESCRIPTION ||
$Description$

|| DEVELOPER ||
$Developer: David Whiterod (whiterod.david@saugov.sa.gov.au) Planning SA$

|| ATTRIBUTES ||
$in: $
$out:$
--->

<cfscript>

/**
 * Qualitative description of a date.
 * 
 * @param date 	 Date you want to return a qualitative description for. 
 * @return Returns a string. 
 * @author Matthew Walker (matthew@cabbagetree.co.nz) 
 * @version 1, April 15, 2002 
 */
function QualitativeDate(Date) {

	var Today = Now();
	var YearsDifference = Year(Today) - Year(Date);
	var MonthsDifference = Month(Today) - Month(Date);
	var WeeksDifference = Week(Today) - Week(Date);
	var DaysDifference = DayOfWeek(Today) - DayOfWeek(Date);
	
	if ( DateCompare(Date, Now()) LT 1 ) {
		if ( YearsDifference GT 2 )
			return "A long time ago";
		if ( YearsDifference EQ 2 )
			return "Two years ago";
		if ( YearsDifference EQ 1 )
			return "Last year";
		if ( MonthsDifference GT 2 )
			return "Earlier this year";
		if ( MonthsDifference EQ 2 )
			return "Two months ago";
		if ( MonthsDifference EQ 1 )
			return "Last month";
		if ( WeeksDifference GT 2 )
			return "Earlier this month";
		if ( WeeksDifference EQ 2 )
			return "Two weeks ago";
		if ( WeeksDifference EQ 1 )
			return "Last week";	
		if ( DaysDifference GT 1 )
			return "Earlier this week";
		if ( DaysDifference EQ 1 )
			return "Yesterday";	
		return "Today";
	}		
	else {
		if ( YearsDifference LT -1 )
			return "Sometime in the future";
		if ( YearsDifference EQ -1 )
			return "Next year";
		if ( MonthsDifference LT -1 )
			return "Later this year";
		if ( MonthsDifference EQ -1 )
			return "Next month";
		if ( WeeksDifference LT 0 )
			return "Later this month";
		if ( DaysDifference LT -2 )
			return "Later this week";
		if ( DaysDifference EQ -2 )
			return "Two days from now";
		if ( DaysDifference EQ -1 )
			return "Tomorrow";	
		return "Today";	
	}		
}

/**
 * Will take a number returned from a File.Filesize, calculate the number in terms of Bytes/Kilobytes/Megabytes and return the result.
 * 
 * @param number 	 Size in bytes of the file. (Required)
 * @return Returns a string. 
 * @author Kyle Morgan (admin@kylemorgan.com) 
 * @version 1, September 16, 2002 
 */
function FncFileSize(size) {
	var result = "";
	var unit = "";
	var decimal = "";
	
	if ((size gte 1024) and (size lt 1048576)) {
		result = size / 1024;
		unit = "KB";
		Decimal = Find(".",Result);
		Result = Left(Result,Decimal + 2);
		Result = Result * 10;
		Result = Round(Result);
		Result = Result / 10;
		Result = Result & " " & unit;
	} 	else if ((size gte 1048576) and (size lt 1073741824)) {
		result = size / 1048576;
		unit = "MB";
		Decimal = Find(".",Result);
		Result = Left(Result,Decimal + 2);
		Result = Result * 100;
		Result = Round(Result);
		Result = Result / 100;
		Decimal = Find(".",Result);
		if (Right(Result,(Len(Result)-Decimal)) EQ 0) {
			Result = Left(Result,((Len(Result)-Decimal)-1)) & " " & unit;
		} else {
			Result = Result & " " & unit;
		}
	}	else if (size LT 1024) {
 			Result = Size;
			unit = "B";
			Result = Result & " " & unit;
	}
	return result;
}

	
/**
 * Displays n number of characters from a string without cutting off in the middle of a word
 * Code used from FullLeft
 *
 * @param string 	 String to be modified. (Required)
 * @param number 	 Number of characters to include in teaser. (Required)
 * @param urlArgument 	 URL to use for 'more' link. (Optional)
 * @return Returns a string.
 * @author Bryan LaPlante (blaplante@netwebapps.com)
 * @version 3, July 31, 2003
 */
function FormatTeaser(string,number){
	var urlArgument = "";
	var shortString = "";

	//return quickly if string is short or no spaces at all
	if(len(string) lte number or not refind("[[:space:]]",string)) return string;

	if(arrayLen(arguments) gt 2) urlArgument = "... <a href=""" & arguments[3] & """>[more]</a>";

	//Full Left code (http://www.cflib.org/udf.cfm?ID=329)
	if(reFind("[[:space:]]",mid(string,number+1,1))) {
	  	shortString = left(string,number);
	} else {
		if(number-refind("[[:space:]]", reverse(mid(string,1,number)))) shortString = Left(string, (number-refind("[[:space:]]", reverse(mid(string,1,number)))));
		else shortString = left(str,1);
	}

	return shortString & urlArgument;

}

/**
 * Tests passed value to see if it is a valid e-mail address (supports subdomain nesting and new top-level domains).
 * Update by David Kearns to support '
 * SBrown@xacting.com pointing out regex still wasn't accepting ' correctly.
 * More TLDs
 * Version 4 by P Farrel, supports limits on u/h
 * 
 * @param str 	 The string to check. (Required)
 * @return Returns a boolean. 
 * @author Jeff Guillaume (jeff@kazoomis.com) 
 * @version 4, December 30, 2005 
 */
function isEmail(str) {
	return (REFindNoCase("^['_a-z0-9-]+(\.['_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*\.(([a-z]{2,3})|(aero|coop|info|museum|name|jobs|travel))$",
		arguments.str) AND len(listGetAt(arguments.str, 1, "@")) LTE 64 AND
		len(listGetAt(arguments.str, 2, "@")) LTE 255) IS 1;
}
</cfscript>
<cfsetting enablecfoutputonly="no" />